<id>
Adult Access Only Mod
</id>

<version>
1.0
</version>

<mod info>
This mod denies access for members below 18 years to any category marked with access to "adult" membergroup only.
If a member enters his true birth date in his profile all categories marked with access "adult" will automatically become visible as soon as this member reaches the age of 18 years or older.
This mod is NOT TESTED with More Membergroups.

How to install ?
As usual install this mod using BoardMod 2.5
This mod modifies Subs.pl, Load.pl and Boardindex.pl, so after Modding upload the changed pl's to the sources dir.
So far you'll see no changes to the board.
Now create a new membergroup named "*ADULT*" (All Caps and a star on both ends)
This membergroup behaves like a normal membergroup, so every category protected with this group acces will only allow members belonging to this group.
So this looks normal, but if a member fills out a correct date of birth and he/she is over 18 years the board also gives them age related access to the categories protected by this membergroup (so you don't have to add adults manually to this group, only encourage them to fill out the proper age in their profile).
Allthough not foolproof (if my kids fill out my birth date they get access) it makes life for adult board admins a lot easier.
</mod info>

<author>
Webmaster Spikecity.net
</author>

<homepage>
http://www.spikecity.net
</homepage>

<edit file>
Sources/Boardindex.pl
</edit file>

<search for>
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }

</search for>

<replace>
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; }
		if($tmpa eq '*ADULT*' && $realage > '17') { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }

</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
				$realemail = $settings[2];

</search for>

<add after>

### Start Adult Mod ###
			my($usermonth, $userday, $useryear);
				if($settings[16] ne '') {
					($usermonth, $userday, $useryear) = split(/\//, $settings[16]);
					if(length($settings[16]) <= 2) { $realage = $settings[16]; }
					else {
					$realage = $year - $useryear;
					if($usermonth > $mon_num || ( $usermonth == $mon_num && $userday > $mday ) ) { --$realage; }
					}
				}
### End Adult Mod ###

</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub BoardAccessGet {
	my $curboard = $_[0];
	&BoardCatGet($curboard);
	if( !$yyAccessCat{$yyCatBoard{$curboard}} && fopen(CATFILE, "$boardsdir/$yyCatBoard{$curboard}.cat") ) {
		my $curcatname = <CATFILE>;
		my $curcataccess = <CATFILE>;
		fclose(CATFILE);
		chomp $curcatname;
		chomp $curcataccess;
		$yyAccessCat{$yyCatBoard{$curboard}} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
		unless( $yyAccessCat{$curcat} ) {
			foreach ( split(/\,/, $curcataccess) ) {
				if( $_ && $_ eq $settings[7]) { $yyAccessCat{$yyCatBoard{$curboard}} = 1; last; }
			}
		}

	}




	return $yyAccessCat{$yyCatBoard{$curboard}};
}

</search for>

<replace>
sub BoardAccessGet {
	my $curboard = $_[0];
	&BoardCatGet($curboard);
	if( !$yyAccessCat{$yyCatBoard{$curboard}} && fopen(CATFILE, "$boardsdir/$yyCatBoard{$curboard}.cat") ) {
		my $curcatname = <CATFILE>;
		my $curcataccess = <CATFILE>;
		fclose(CATFILE);
		chomp $curcatname;
		chomp $curcataccess;
		$yyAccessCat{$yyCatBoard{$curboard}} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
		unless( $yyAccessCat{$curcat} ) {
			foreach ( split(/\,/, $curcataccess) ) {
				if(( $_ && $_ eq $settings[7]) || ($_ && ($_ eq '*ADULT*' && $realage > '17'))) { $yyAccessCat{$yyCatBoard{$curboard}} = 1; last; }
			}
		}

	}




	return $yyAccessCat{$yyCatBoard{$curboard}};
}

</replace>